<?php

/*
/ Vrifie la connexion a la base
*/
function verif_connex()
{
	global $db;
	if(!$db->connect())
	{
		return false;
	}
	else
	{
		return true;
	}
	$db->close();
}

/*
/ Affiche le message d'erreur '$msg' 
*/
function error_msg($msg)
{
	echo "<br><br><center><font color=red><b> " . $msg . " </b></font><br><br><br></center>$back";
}

/*
/ Cre l'entete du cadre de titre $titre
*/
function cadre_deb($titre)
{
	echo "<table width=100% cellpadding=0 cellspacing=0>
			<col width=1 bgcolor='#2D7DA7'>
			<col>
			<col width=1 bgcolor='#2D7DA7'>
    		<tr>
				<td></td>
      			<td bgcolor='#2D7DA7' align='center' class=tmenu>$titre</td>
				<td></td>
    		</tr>
    		<tr>
				<td></td>
      			<td bgcolor='#ABD5D5'>
				<table width=97% align=center><tr><td class=texte>";
}

/*
/ Termine le cadre
*/
function cadre_fin()
{
	echo "</td></tr></table>
				</td>
				<td></td>
    		</tr>
    		<tr>
      			<td height=1 colspan=3></td>
    		</tr>
  		</table>";
}

/*
/ Retourne le nombre de commentaires de la news d'id  '$id_news'
*/
function nb_comments($id_news)
{
	global $db,$tbl_comments;
	
	$db->query("SELECT * FROM " . $tbl_comments . " WHERE id_news='" . $id_news . "'");
	return $db->num_rows();
}

/*
/ Retourne le template d'id '$id_tpl'
*/
function template($id_tpl)
{
	global $tbl_tpl,$form_archives,$PATH_SITE,$PATH_SCRIPT,$dbhost,$dbbase,$dbuser,$dbpass;
	$db2 = new db_mysql($dbhost,$dbbase,$dbuser,$dbpass);
	$db2->connect();
	$db2->query("SELECT template FROM " . $tbl_tpl . " WHERE id='" . $id_tpl . "'");
	$db2->nextrecord();
	$tpl = stripslashes($db2->valeur('template'));
	$tpl = str_replace("{FORMARCHIVES}",$form_archives,$tpl);
	$tpl = str_replace("{ARCHIVES}","<a href='".$PATH_SITE.$PATH_SCRIPT."archives.php' target='_blank' class=ltexte>",$tpl);
	$tpl = str_replace("{/ARCHIVES}","</a>",$tpl);
	$tpl = str_replace("{SUBMIT}","<a href='".$PATH_SITE.$PATH_SCRIPT."submit_news.php' target='_blank' class=ltexte>",$tpl);
	$tpl = str_replace("{/SUBMIT}","</a>",$tpl);
	$db2->close();
	return $tpl;
}

/*
/ Retourne la requete a executer pour la recherche de '$chaine' dans le champ '$champ'
*/
function search($chaine,$champ)
{
	$chaine = trim(strtolower($chaine));
	$chaine = ereg_replace("[\'\"!?,;:&]","",$chaine);
	$chaine = ereg_replace("\+"," ",$chaine);
	$chaine = ereg_replace('[a]','[a]',$chaine);
	$chaine = ereg_replace('[o]','[o]',$chaine);
	$chaine = ereg_replace('[e]','[e]',$chaine);
	$chaine = ereg_replace('[c]','[c]',$chaine);
	$chaine = ereg_replace('[i]','[i]',$chaine);
	$chaine = ereg_replace('[u]','[u]',$chaine);
	$chaine = ereg_replace('[y]','[y]',$chaine);
	$chaine = ereg_replace('[n]','[n]',$chaine);
	$chaineretour  = $champ . " REGEXP '";
	if (strstr($chaine," "))
	{
		$chaineretour .= ereg_replace('([^ ]*)([ ]*)([^ ]+)','\\1|\\3',$chaine)."'";
	}
	else
	{
		$chaineretour .= $chaine. "'";
	}
	
	return $chaineretour;
}

/*
/ Mise  jour des sessions
*/
function sessions_maj($session_id)
{
	global $db,$DUREE_SESSION,$tbl_sessions;
	
	if (!empty($session_id))
	{
		// Suppression des sessions primes
		$db->query("SELECT * FROM $tbl_sessions WHERE session_id='$session_id'");
		$db->nextrecord();
		$session_start = $db->valeur('session_start');
		$user_id = $db->valeur('user_id');
		$db->query("SELECT * FROM $tbl_sessions WHERE user_id='$user_id'");
		if ($db->num_rows() > 1)
		{
			while($db->nextrecord())
			{
				$session_start = $db->valeur('session_start');
				if (time() - $session_start > $DUREE_SESSION)
				{
					$session_id = $db->valeur('session_id');
					$db->query("DELETE FROM $tbl_sessions WHERE session_id='$session_id'");
				}
			}
		}
		if (time() - $session_start > $DUREE_SESSION)
		{
			$db->query("DELETE FROM $tbl_sessions WHERE session_id='$session_id'");
		}
		else
		{
			$now=time();
			$db->query("UPDATE $tbl_sessions SET session_start='$now' WHERE session_id='$session_id'");
		}
	}
}

/*
/ Renvoie true si la session $session_id est ouverte, false sinon
*/
function session_open($session_id)
{
	global $db,$tbl_sessions;

	if (empty($session_id))
	{
		return false;
	}
	else
	{
		$db->query("SELECT * FROM $tbl_sessions WHERE session_id='".$session_id."'");
		if ($db->num_rows() == 1)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

/*
/ Installe un cookie avec user/pass
*/
function envoiecookie($user,$pass)
{
	global $site,$duree_cookie;
	setcookie("$site","$user|$pass",time()+$duree_cookie);
}

/*
/ Cre une session
*/
function make_session($user,$pass)
{
	global $db,$tbl_sessions,$tbl_users;
	
	$db->query("SELECT user FROM " . $tbl_users . " WHERE user='" . $user . "'");
	$db->nextrecord();
	$user_id = $db->valeur('user'); // respecte les majuscules d'un pseudo
	
	$session_id = md5(uniqid(rand()));
	
	$session_start = time();
	// Autorise ou non 2 connexions simultanes du meme accompte.
	//$db->query("DELETE FROM " . $tbl_sessions . " WHERE user_id='" . $user_id . "'");
	
	// On cre la nouvelle session.
	$db->query("INSERT INTO " . $tbl_sessions . " VALUES('" . $session_id . "','" . $user_id . "','" . $session_start . "')") or die($db->error);	
	
	return $session_id;
}

/*
/ Vrifie si les logins//pass de l'utilisateur sont ok
*/
function verif_user($user,$pass)
{
	global $db,$tbl_users,$user;
	
	if(empty($user) || empty($pass))
	{
		return false;
	}
	$db->query("SELECT user,mdp FROM " . $tbl_users . " WHERE user='" . $user . "'");
	$db->nextrecord();
	if($db->valeur('mdp') == $pass)
	{
		return true;
	}
	else
	{
		return false;
	} 
}

/*
/ Renvoie un tableau contenant l'id et l'email de l'admin connect
*/
function check_author()
{
	global $db,$tbl_sessions,$tbl_users,$session_id;
	
	$db->query("SELECT user_id FROM " . $tbl_sessions . " WHERE session_id='" . $session_id . "'");
	$db->nextrecord();
	$user_id = $db->valeur('user_id');
	$db->query("SELECT email FROM " . $tbl_users . " WHERE user='" . $user_id . "'");
	$db->nextrecord();
	$user_email = $db->valeur('email');
	return array($user_id,$user_email);
}

/*
/ Vrifi si l'admin a acces au niveau '$lvl'
*/
function check_lvl($lvl)
{
	global $db,$tbl_sessions,$tbl_users,$session_id;
	
	$drp = false;
	if (empty($lvl))
	{
		$drp = false;
	}
	$db->query("SELECT user_id FROM " . $tbl_sessions . " WHERE session_id='" . $session_id . "'");
	if ($db->num_rows() != 1)
	{
		$drp = false;
	}
	else
	{
		$db->nextrecord();
		$user_id = $db->valeur('user_id');
		$db->query("SELECT id FROM " . $tbl_users . " WHERE " . $lvl . "='1' AND user='" . $user_id . "'");
		if ($db->num_rows() != 1)
		{
			$drp = false;
		}
		else
		{
			$drp = true;
		}
	}
	
	if (!$drp)
	{
		header('location:refuse.php');
	}
}


/*
/ Vrifie si la session en cours est toujours valide
*/
function verif_session()
{
	global $session_id;
	
	sessions_maj($session_id);
	if (!session_open($session_id))
	{
		header("Location: auth.php");
	}
}

/*
/ Renvoie la news d'id $id_news pour le type (archive, news, news2) $type
*/
function ret_news($id_news,$type)
{
	global $db,$tbl_news,$tbl_words,$tbl_smiley,$PATH_SCRIPT,$PATH_SITE,$SOURCE_CH_MAX,$SOURCE_PERSO,$DATE_FORMAT,$TIME_FORMAT;
	
	$affnews = template($type);
	
	$db->query("SELECT * FROM " . $tbl_news . " WHERE id=" . $id_news);
	$db->nextrecord();
	
	$titre_n = stripslashes($db->valeur('titre'));
	$texte_n = stripslashes($db->valeur('texte'));
	$source_n = stripslashes($db->valeur('source'));
	$nm_source_n = stripslashes($db->valeur('nm_source'));
	$auteur_n = stripslashes($db->valeur('auteur'));
	$email_n = stripslashes($db->valeur('aut_email'));
	$icon = $db->valeur('icone');
	
	$date_news = $db->valeur('date_news');
	$date = date($DATE_FORMAT,$date_news);
	$time = date($TIME_FORMAT,$date_news);
	$db->free();
	
	if (!empty($source_n))
	{
		$h_source = template('source_header');
		$f_source = template('source_footer');
		if ($SOURCE_PERSO == 1)
		{
			if (empty($nm_source_n))
			{
				$m_source = template('source');
			}
			else
			{
				$m_source = $nm_source_n;
			}
		}
		else
		{
			$m_source = substr($source_n,0,$SOURCE_CH_MAX);
			if (strlen($source_n) > $SOURCE_CH_MAX)
			{
				$m_source .= "...";
			}
		}
		$affnews = str_replace("{SOURCE}",$h_source."<a href='".$source_n."' target='_blank'>" . $m_source . "</a> ".$f_source,$affnews);
	}
	else
	{
		$affnews = str_replace("{SOURCE}","",$affnews);
	}
	$affnews = str_replace("{TITRE}",$titre_n,$affnews);
	$affnews = str_replace("{TEXTE}",$texte_n,$affnews);
	$db->query("SELECT * FROM ".$tbl_smiley." WHERE active=1");
	while ($db->nextrecord())
	{
		$affnews = str_replace($db->valeur('smiley'),"<img src=\"".$db->valeur('url')."\" border=0 alt=\"".$db->valeur('nom')."\">",$affnews);
	}
	$affnews = str_replace("{DATE}",$date,$affnews);
	$affnews = str_replace("{TIME}",$time,$affnews);
	$affnews = str_replace("{AUTEUR}",$auteur_n,$affnews);
	$affnews = str_replace("{EMAIL}",$email_n,$affnews);
	$affnews = str_replace("{NBCOMMENT}",nb_comments($id_news),$affnews);
	$affnews = str_replace("{PRINT}","<a href='".$PATH_SITE.$PATH_SCRIPT."print.php?id_news=" . $id_news . "' target='_blank' class=ltexte>",$affnews);
	$affnews = str_replace("{/PRINT}","</a>",$affnews);
	$affnews = str_replace("{COMMENTS}","<a href='javascript:show_comments($id_news);' class=ltexte>",$affnews);
	$affnews = str_replace("{/COMMENTS}","</a>",$affnews);
	$affnews = str_replace("{VIEW}","<a href='".$PATH_SITE.$PATH_SCRIPT."show_news.php?id_news=" . $id_news . "' target='_blank' class=ltexte>",$affnews);
	$affnews = str_replace("{/VIEW}","</a>",$affnews);
	if (!empty($icon))
	{
		$icon_n = "<img src=\"".$PATH_SITE.$PATH_SCRIPT."images/icons/".stripslashes($icon)."\" border=0>";
	}
	$affnews = str_replace("{ICON}",$icon_n,$affnews);
	
	$db->query("SELECT * FROM ".$tbl_words." WHERE active=1");
	while ($db->nextrecord())
	{
		$affnews = str_replace($db->valeur('mot1'),$db->valeur('mot2'),$affnews);
	}
	return $affnews;
}


/*
/ Dcoupe la requete SQL $sql par les $delimiter
*/
function split_sql_file($sql, $delimiter)
{

	$tokens = explode($delimiter, $sql);

	$sql = "";
	$output = array();
	$matches = array();
	$token_count = count($tokens);
	for ($i = 0; $i < $token_count; $i++)
	{
		if (($i != ($token_count - 1)) || (strlen($tokens[$i] > 0)))
		{
			$total_quotes = preg_match_all("/'/", $tokens[$i], $matches);
			$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$i], $matches);
			$unescaped_quotes = $total_quotes - $escaped_quotes;
			
			if (($unescaped_quotes % 2) == 0)
			{
				$output[] = $tokens[$i];
				$tokens[$i] = "";
			}
			else
			{
				$temp = $tokens[$i] . $delimiter;
				$tokens[$i] = "";
				$complete_stmt = false;
				
				for ($j = $i + 1; (!$complete_stmt && ($j < $token_count)); $j++)
				{
					$total_quotes = preg_match_all("/'/", $tokens[$j], $matches);
					$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$j], $matches);
			
					$unescaped_quotes = $total_quotes - $escaped_quotes;
					
					if (($unescaped_quotes % 2) == 1)
					{
						$output[] = $temp . $tokens[$j];

						$tokens[$j] = "";
						$temp = "";
						
						$complete_stmt = true;
						$i = $j;
					}
					else
					{
						$temp .= $tokens[$j] . $delimiter;
						$tokens[$j] = "";
					}
					
				}
			}
		}
	}

	return $output;
}

/*
/ Retire les commentaires de la requete SQL $sql
*/
function remove_remarks($sql)
{
	$lignes = explode("\n", $sql);
	
	$sql = "";
	
	$cpt_ligne = count($lignes);
	$output = "";

	for ($i = 0; $i < $cpt_ligne; $i++)
	{
		if (($i != ($cpt_ligne - 1)) || (strlen($lignes[$i]) > 0))
		{
			if ($lignes[$i][0] != "#")
			{
				$output .= $lignes[$i] . "\n";
			}
			else
			{
				$output .= "\n";
			}
			$lignes[$i] = "";
		}
	}
	return $output;
}

/*
/ Execute la requete sql contenue dans le fichier '$file'
*/
function file_to_sql($file)
{
	global $db;
	$fp = fopen($file, 'r');
	$sql_query = fread($fp, filesize($file));
	$sql_query = remove_remarks($sql_query);
	$pieces = split_sql_file($sql_query, ";");
	
	$sql_count = count($pieces);
	for($i = 0; $i < $sql_count; $i++)
	{
		$sql = trim($pieces[$i]);
	
		if(!empty($sql) and $sql[0] != "#")
		{
			$db->query($sql);
		}
	}
}

/*
/ Sauvegarde le skin en cours dans le fichier '$file'
*/
function sql_to_file($file)
{
	global $dbhost,$dbbase,$dbuser,$dbpass,$tbl_tpl;
	
	$tabledump = "DROP TABLE IF EXISTS ".$tbl_tpl.";
	CREATE TABLE ".$tbl_tpl." (
	  id varchar(100) NOT NULL default '',
	  template text NOT NULL,
	  nom varchar(30) NOT NULL default ''
	) TYPE=MyISAM;
	";
	
	@mysql_connect($dbhost,$dbuser,$dbpass);
	@mysql_select_db($dbbase);
	
	$rows = mysql_query("SELECT * FROM ".$tbl_tpl);
	$numfields = mysql_num_fields($rows);

	while ($row = mysql_fetch_array($rows))
	{
		$tabledump .= "INSERT INTO ".$tbl_tpl." VALUES(";
	
		$cptchamp=-1;
		$firstfield=1;

		while (++$cptchamp<$numfields)
		{
			if (!$firstfield)
			{
				$tabledump.=",";
			} 
			else
			{
				$firstfield=0;
			}
	
			if (!isset($row[$cptchamp]))
			{
				$tabledump .= "NULL";
			}
			else
			{
				$tabledump .= "'".mysql_escape_string($row[$cptchamp])."'";
			}
		}
	
		$tabledump .= ");\n";
	}
	@mysql_free_result($rows);
	$fd = fopen($file.".skin","w");
	fwrite($fd, "##\n");
	fwrite($fd, "## Xt-News Skin : ".$file."\n");
	fwrite($fd, "##\n\n");
	fwrite($fd, $tabledump);
	fclose($fd);
}

/*
/ Transforme la taille $taille en octets, en une unit plus approprie
*/
function taille($taille)
{
	global $size_unit;
	if ($taille >= 1073741824)
	{
		$format = round($taille / 1073741824 * 100) / 100 . " Go";
	}
	elseif ($taille >= 1048576)
	{
		$format = round($taille / 1048576 * 100) / 100 . " Mo";
	}
	elseif ($taille >= 1024)
	{
		$format = round($taille / 1024 * 100) / 100 . " Ko";
	}
	else
	{
		$format = $taille . " octets";
	}
	if($taille==0)
	{
		$format="-";
	}
	return $format;
}
?>
